package hr.webtech.pay2.example;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import java.util.List;

import ba.leftor.android.pikpay.R;
import hr.webtech.pay2.data.PaymentMethod;
import rx.functions.Action1;

/**
 * Created by jasminsuljic on 03/08/2018.
 * pgw-android
 */
public class PaymentMethodAdapter extends StableArrayAdapter<PaymentMethod> {

    PaymentMethodAdapter(Context context, List<PaymentMethod> objects, Action1<PaymentMethod> onClickAction) {
        super(context, objects, onClickAction);
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        LayoutInflater inflater = (LayoutInflater) parent.getContext()
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View rowView = inflater.inflate(R.layout.payment_method_item, parent, false);

        final PaymentMethod paymentMethod = values.get(position);

        final Button button = (Button) rowView.findViewById(R.id.payment_method);

        button.setText(String.format("merchant: %s\nmasked-pan: %s\ncard-type: %s\nexpires soon:%s\nyear: %s, month: %s",
                paymentMethod.getMerchantId(),
                paymentMethod.getMaskedPan(),
                paymentMethod.getCardType(),
                paymentMethod.getExpiresSoon(),
                paymentMethod.getYear(),
                paymentMethod.getMonth()
        ));

        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PaymentMethodAdapter.this.onClick(paymentMethod);
            }
        });

        return rowView;
    }
}
