package hr.webtech.pay2.data;

import android.os.Parcel;
import android.os.Parcelable;
import android.support.annotation.NonNull;

import static hr.webtech.pay2.util.Objects.requireNonNull;

/**
 * Created by jasminsuljic on 29/05/2018.
 * WebtehPaymentLib
 */

public final class Merchant implements Parcelable {
    private final String merchantId;
    private final String authenticationToken;
    private final String authenticityToken;
    private final String merchantKey;
    private final String clientSecret;

    public Merchant(@NonNull String merchantId,
                    @NonNull String authenticationToken,
                    @NonNull String authenticityToken,
                    @NonNull String merchantKey,
                    @NonNull String clientSecret) {
        this.merchantId = requireNonNull(merchantId);
        this.authenticationToken = requireNonNull(authenticationToken);
        this.authenticityToken = requireNonNull(authenticityToken);
        this.merchantKey = requireNonNull(merchantKey);
        this.clientSecret = requireNonNull(clientSecret);
    }

    public String getMerchantId() {
        return merchantId;
    }

    public String getAuthenticationToken() {
        return authenticationToken;
    }

    public String getAuthenticityToken() {
        return authenticityToken;
    }

    public String getMerchantKey() {
        return merchantKey;
    }

    public String getClientSecret() {
        return clientSecret;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(this.merchantId);
        dest.writeString(this.authenticationToken);
        dest.writeString(this.authenticityToken);
        dest.writeString(this.merchantKey);
        dest.writeString(this.clientSecret);
    }

    protected Merchant(Parcel in) {
        this.merchantId = in.readString();
        this.authenticationToken = in.readString();
        this.authenticityToken = in.readString();
        this.merchantKey = in.readString();
        this.clientSecret = in.readString();
    }

    public static final Parcelable.Creator<Merchant> CREATOR = new Parcelable.Creator<Merchant>() {
        @Override
        public Merchant createFromParcel(Parcel source) {
            return new Merchant(source);
        }

        @Override
        public Merchant[] newArray(int size) {
            return new Merchant[size];
        }
    };
}
