package hr.webtech.pay2.data;

/**
 * Created by jasminsuljic on 19/12/16.
 * pgw-android
 */

import android.os.Parcel;
import android.os.Parcelable;
import android.support.annotation.Nullable;

import com.google.gson.annotations.Expose;
import com.google.gson.annotations.SerializedName;

@SuppressWarnings("unused")
/**
 * Check <a href='https://gist.github.com/jasminsuljic/18ab52d1d43de14df5c9cc1ea267b572'>json schema</a>
 */
public final class TransactionSuccess implements Parcelable {

    @Expose
    @SerializedName("id")
    private int id;

    @Expose
    @SerializedName("card_type")
    private String cardType;

    @Nullable
    @Expose
    @SerializedName("pm_alias")
    private String pmAlias;

    @Expose
    @SerializedName("ch_email")
    private String email;

    @Expose
    @SerializedName("ch_full_name")
    private String fullName;

    @Expose
    @SerializedName("response_code")
    private String responseCode;

    @Expose
    @SerializedName("approval_code")
    private String approvalCode;

    @Expose
    @SerializedName("status")
    private String status;

    @Expose
    @SerializedName("merchant_id")
    private String merchantId;

    @Expose
    @SerializedName("masked_pan")
    private String maskedPan;

    @Expose
    @SerializedName("response_message")
    private String responseMessage;

    @Expose
    @SerializedName("amount")
    private float amount;

    @Nullable
    @Expose
    @SerializedName("expiry_date")
    private String expiryDate;

    @Nullable
    @Expose
    @SerializedName("user_id")
    private String userId;

    protected TransactionSuccess(Parcel in) {
        id = in.readInt();
        cardType = in.readString();
        pmAlias = in.readString();
        email = in.readString();
        fullName = in.readString();
        responseCode = in.readString();
        approvalCode = in.readString();
        status = in.readString();
        merchantId = in.readString();
        maskedPan = in.readString();
        responseMessage = in.readString();
        amount = in.readFloat();
        expiryDate = in.readString();
        userId = in.readString();
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(id);
        dest.writeString(cardType);
        dest.writeString(pmAlias);
        dest.writeString(email);
        dest.writeString(fullName);
        dest.writeString(responseCode);
        dest.writeString(approvalCode);
        dest.writeString(status);
        dest.writeString(merchantId);
        dest.writeString(maskedPan);
        dest.writeString(responseMessage);
        dest.writeFloat(amount);
        dest.writeString(expiryDate);
        dest.writeString(userId);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public static final Creator<TransactionSuccess> CREATOR = new Creator<TransactionSuccess>() {
        @Override
        public TransactionSuccess createFromParcel(Parcel in) {
            return new TransactionSuccess(in);
        }

        @Override
        public TransactionSuccess[] newArray(int size) {
            return new TransactionSuccess[size];
        }
    };

    public int getId() {
        return id;
    }

    public String getFullName() {
        return fullName;
    }

    public String getApprovalCode() {
        return approvalCode;
    }

    public String getCardType() {
        return cardType;
    }

    public String getEmail() {
        return email;
    }

    @Nullable
    public String getPmAlias() {
        return pmAlias;
    }

    public String getResponseCode() {
        return responseCode;
    }

    public String getStatus() {
        return status;
    }

    public float getAmount() {
        return amount;
    }

    public String getMaskedPan() {
        return maskedPan;
    }

    public String getMerchantId() {
        return merchantId;
    }

    public String getResponseMessage() {
        return responseMessage;
    }

    @Nullable
    public String getExpiryDate() {
        return expiryDate;
    }

    @Nullable
    public String getUserId() {
        return userId;
    }

    @Override
    public String toString() {
        return "TransactionSuccess{" + "id=" + id +
                ", cardType='" + cardType + '\'' +
                ", pmAlias='" + pmAlias + '\'' +
                ", email='" + email + '\'' +
                ", fullName='" + fullName + '\'' +
                ", responseCode='" + responseCode + '\'' +
                ", approvalCode='" + approvalCode + '\'' +
                ", status='" + status + '\'' +
                ", merchantId='" + merchantId + '\'' +
                ", maskedPan='" + maskedPan + '\'' +
                ", responseMessage='" + responseMessage + '\'' +
                ", amount=" + amount +
                ", expiryDate='" + expiryDate + '\'' +
                ", userId='" + userId + '\'' +
                '}';
    }
}
