package hr.webtech.pay2.data;

import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

import hr.webtech.pay2.util.Objects;

/**
 * Created by jasminsuljic on 01/08/2018.
 * pgw-android
 */
public class UpdatePaymentResponse {

    @Nullable
    private UpdatePaymentMethodSuccess successResponse;
    @Nullable
    private UpdatePaymentMethodError errorResponse;

    public UpdatePaymentResponse(@Nullable UpdatePaymentMethodSuccess successResponse, @Nullable UpdatePaymentMethodError errorResponse) {
        this.successResponse = successResponse;
        this.errorResponse = errorResponse;
    }

    public boolean succeded() {
        return successResponse != null;
    }

    public boolean failed() {
        return !succeded();
    }

    public static UpdatePaymentResponse create(@NonNull UpdatePaymentMethodSuccess successResponse) {
        return new UpdatePaymentResponse(Objects.requireNonNull(successResponse, "successResponse == null"), null);
    }

    public static UpdatePaymentResponse create(@NonNull UpdatePaymentMethodError deletePaymentMethodError) {
        return new UpdatePaymentResponse(null, Objects.requireNonNull(deletePaymentMethodError, "deletePaymentMethodError == null"));
    }

    @Nullable
    public UpdatePaymentMethodSuccess getSuccessResponse() {
        return successResponse;
    }

    @Nullable
    public UpdatePaymentMethodError getErrorResponse() {
        return errorResponse;
    }
}
