package hr.webtech.pay2.data;

/**
 * Created by jasminsuljic on 23/01/17.
 * pgw-android
 */

import hr.webtech.pay2.R;

/**
 * Presents in library exceptions. Every instance has {@link #code} which uniquely identifies error.
 * <p>
 * Error codes are randomly generated in {@link R.id} class.
 * <p>
 * For checking error codes use {@link #isError(int)}
 */
public class WebtehErrorException extends RuntimeException {

    private int code;

    public static final int parsingError = R.integer.exception_parsing_error;

    public WebtehErrorException(int code) {
        this.code = code;
    }

    public static WebtehErrorException parsingError() {
        return new WebtehErrorException(parsingError);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        WebtehErrorException that = (WebtehErrorException) o;

        return code == that.code;

    }

    /**
     * Check if error code matches send code without instantiating {@link WebtehErrorException}
     * <p/>
     *
     * @param code error code
     * @return
     */
    public boolean isError(int code) {
        return this.code == code;
    }

    @Override
    public int hashCode() {
        return code;
    }
}
