package hr.webtech.pay2.view;

import hr.webtech.pay2.data.PaymentMethod;

/**
 * Represents add payment method lifecycle. Methods are invoked from {@link RedirectResolver} or from {@link TransactionLifecycleAdapter}
 * <p>
 * For detailed transaction lifecycle check <a href="https://mobile.webteh.hr/site/docs?type=android">documentation</a>
 *
 * @author jasminsuljic
 * @version 1.4.1
 */
public interface AddPaymentMethodLifecycleDelegate extends SharedLifecycleDelegate {

    /**
     * Invoked after successfully saving payment method
     *
     * @param paymentMethod
     */
    void addPaymentMethodSuccess(PaymentMethod paymentMethod);
}
