package hr.webtech.pay2.view;

import hr.webtech.pay2.api.PgwApi;
import hr.webtech.pay2.data.ShowOrderResponse;
import hr.webtech.pay2.data.TransactionSuccess;

/**
 * Created by jasminsuljic on 20/12/16.
 * pgw-android
 */

/**
 * Represents transaction lifecycle. Methods are invoked from {@link RedirectResolver} or from {@link TransactionLifecycleAdapter}
 * <p>
 * For detailed transaction lifecycle check <a href="https://mobile.webteh.hr/site/docs?type=android">documentation</a>
 *
 * @author jasminsuljic
 * @version 1.4.1
 */
public interface TransactionLifecycleDelegate extends SharedLifecycleDelegate {

    /**
     * Transaction success. Invoked after successful transaction or after checking
     * transactions status within {@link TransactionLifecycleAdapter#timeout()}
     * <p>
     * <b>Note: <b/> business logic is not implemented in library!
     *
     * @param transactionSuccess the transaction success
     */
    void transactionSuccess(TransactionSuccess transactionSuccess);

    /**
     * Check order id success.
     *
     * @param showOrderResponse the show order response
     * @deprecated Use {@link #transactionSuccess(TransactionSuccess)} Invoked if {@link PgwApi#checkOrderId(String, String)} is successful
     */
    @Deprecated
    void checkOrderIdSuccess(ShowOrderResponse showOrderResponse);
}
