package hr.webtech.pay2.api;

import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.function.Consumer;

/**
 * Created by jasminsuljic on 03/08/2018.
 * pgw-android
 */
public class PgwApiProxyTest {

    @Test
    public void toExpiryDate() {


        List<Pair<Integer, String>> list = new ArrayList<>();

        list.add(Pair.of(0, "2020-01"));
        list.add(Pair.of(1, "2020-02"));
        list.add(Pair.of(2, "2020-03"));
        list.add(Pair.of(3, "2020-04"));
        list.add(Pair.of(4, "2020-05"));
        list.add(Pair.of(5, "2020-06"));
        list.add(Pair.of(6, "2020-07"));
        list.add(Pair.of(7, "2020-08"));
        list.add(Pair.of(8, "2020-09"));
        list.add(Pair.of(9, "2020-10"));
        list.add(Pair.of(10, "2020-11"));
        list.add(Pair.of(11, "2020-12"));

        list.forEach(new Consumer<Pair<Integer, String>>() {
            @Override
            public void accept(Pair<Integer, String> integerStringPair) {
                Calendar calendar = Calendar.getInstance();
                calendar.set(Calendar.DAY_OF_MONTH, 1);
                calendar.set(Calendar.MONTH, integerStringPair.first);
                calendar.set(Calendar.YEAR, 2020);

                Date date = calendar.getTime();

                final String expiryDate = PgwApiProxy.toExpiryDate(date);

                Assert.assertEquals(integerStringPair.second, expiryDate);
            }
        });


    }

    static class Pair<T, K> {
        T first;
        K second;

        public Pair(T first, K second) {
            this.first = first;
            this.second = second;
        }

        static <O, P> Pair<O, P> of(O o, P p) {
            return new Pair<>(o, p);
        }
    }
}