package hr.webtech.pay2.data;

import com.google.gson.Gson;

import org.junit.Test;

import static org.junit.Assert.assertEquals;

/**
 * Created by jasminsuljic on 01/08/2018.
 * pgw-android
 */
public class PaymentMethodTest {

    @Test
    public void testGsonCreate() {

        String json = "{\n" +
                "            \"id\": \"4FEjlZ_EOOMMjcKQsyLotY_k_tj2iGiIwN6A1sLS\",\n" +
                "            \"name\": \"John Smith\",\n" +
                "            \"user_id\": \"test@test.com\",\n" +
                "            \"card_type\": \"visa\",\n" +
                "            \"masked_pan\": \"***-4242\",\n" +
                "            \"year\": \"2021\",\n" +
                "            \"month\": \"10\",\n" +
                "            \"expires_soon\": false\n" +
                "        }";

        final Gson gson = new Gson();

        final PaymentMethod paymentMethod = gson.fromJson(json, PaymentMethod.class);

        assertEquals("4FEjlZ_EOOMMjcKQsyLotY_k_tj2iGiIwN6A1sLS", paymentMethod.getId());
        assertEquals("John Smith", paymentMethod.getName());
        assertEquals("test@test.com", paymentMethod.getUserId());
        assertEquals("visa", paymentMethod.getCardType());
        assertEquals("***-4242", paymentMethod.getMaskedPan());
        assertEquals("2021", paymentMethod.getYear());
        assertEquals("10", paymentMethod.getMonth());
        assertEquals(false, paymentMethod.getExpiresSoon());
    }
}
